!    Copyright (C) 2006 Imperial College London and others.
!
!    Please see the AUTHORS file in the main source directory for a full list
!    of copyright holders.
!
!    Prof. C Pain
!    Applied Modelling and Computation Group
!    Department of Earth Science and Engineering
!    Imperial College London
!
!    amcgsoftware@imperial.ac.uk
!
!    This library is free software; you can redistribute it and/or
!    modify it under the terms of the GNU Lesser General Public
!    License as published by the Free Software Foundation,
!    version 2.1 of the License.
!
!    This library is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!    Lesser General Public License for more details.
!
!    You should have received a copy of the GNU Lesser General Public
!    License along with this library; if not, write to the Free Software
!    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
!    USA

subroutine vtu2triangle(filename, filename_len)
  !!< Read in a triangle mesh and output a vtu mesh.
  
  use fields
  use state_module
  use write_triangle
  use vtk_interfaces
  
  implicit none
  
  integer, intent(in) :: filename_len
  
  character(len=filename_len), intent(in) :: filename
  
  type(vector_field), pointer :: positions
  type(state_type) :: state

  call vtk_read_state(filename // ".vtu", state)
  positions => extract_vector_field(state, "Coordinate")
  call add_faces(positions%mesh)
  call write_triangle_files(filename, positions, print_internal_faces=.true.)
  
  call deallocate(state)

end subroutine vtu2triangle
